cchessbd 发表于 2023-4-26 08:34:27

块缩放后(调整了XY比例),怎么把文字大小变为原来的呢?

本帖最后由 cchessbd 于 2023-4-26 08:47 编辑

如题:有时候需要把块缩放,文字也跟着缩放了,但是我还是想要原来文字的高度与比例,这样打印才能看清楚。


请大侠指点一下,或者有批量修改文字大小比例的代码,应该也可以解决这个问题。

x_s_s_1 发表于 2023-4-26 11:57:10

本帖最后由 x_s_s_1 于 2023-4-26 16:33 编辑

未测试,修改文字高宽比
(defun c:tt(/ w ss n en)
    (if    (null **texthw**)
    (setq **texthw** 0.8))
    (setq w         (getreal (strcat "\n高宽比:<" (rtos **texthw** 2 2) ">"))
      w         (if w
             w
             **texthw**)
      **texthw** w
      ss         (ssget '((0 . "text"))))
    (repeat (setq n (sslength ss))
    (setq en (ssname ss (setq n (1- n)))
          en (entget en)
          en (subst (cons 41 w) (assoc 41 en) en))
    (entmod en))
    (princ))
修改文字高
(defun c:tt1(/ h ss n en)
    (if    (null **texth**)
    (setq **texth** 300.0))
    (setq h         (getreal (strcat "\n字高:<" (rtos **texth** 2 2) ">"))
      h      (if h
             h
             **texth**)
      **texthw** h
      ss         (ssget '((0 . "text"))))
    (repeat (setq n (sslength ss))
    (setq en (ssname ss (setq n (1- n)))
          en (entget en)
          en (subst (cons 40 h) (assoc 40 en) en))
    (entmod en))
    (princ))

cchessbd 发表于 2023-4-26 15:46:11

本帖最后由 cchessbd 于 2023-4-26 15:56 编辑

x_s_s_1 发表于 2023-4-26 11:57
未测试
(setq w         (getreal "\n高宽比:")
      ss (ssget '((0 . "text"))))
(repeat      (setq n (sslength ss))
    (setq en (ssname (setq n (1- n)) ss)
          en (entget en)
          en (subst (cons 41 w) (assoc 41 en) en))
    (entmod en))
谢谢回复,大概测了一下,CAD2008报错不能运行。
修改了一下,这样可以运行了,就是水平位置稍微有点问题。

(setq w 0.7)
(setq ss (ssget '((0 . "text"))))
(setq n (sslength ss))
(repeat n
    (setq n (1- n)
          en (ssname ss n)
          en (entget en)
          en (subst (cons 41 w) (assoc 41 en) en))
    (entmod en))

cchessbd 发表于 2023-4-26 10:54:12

本帖最后由 cchessbd 于 2023-4-26 10:56 编辑

liuhe 发表于 2023-4-26 10:33
你上图纸吧,写好原图形和目标图形
感谢大侠来研究,,,主要是我这个元素太多了,一项项改真的很累。。。
而且几十个桥。。。

其实我一直想把钻孔数据直接按比例尺生成纵断面,这样就不用考虑缩放的问题。
而且可以随时根据孔号来生成。这样自由度就很高了。
但是钻孔数据变成CAD图我还没研究出来。囧。。。

如果大侠有兴趣,可以看我的帖子,成功可付费
http://bbs.mjtd.com/thread-186533-1-1.html





liuhe 发表于 2023-4-26 08:42:34

那你还想保留原来的块么?要么炸开块,要么修改来的块定义。

cchessbd 发表于 2023-4-26 08:45:07

liuhe 发表于 2023-4-26 08:42
那你还想保留原来的块么?要么炸开块,要么修改来的块定义。
块不需要保留,主要是文字最好保留之前的。
比如,我的操作是,选择一些对象,建块,缩放。
建块是很容易的,我找到了快速建块的代码。

liuhe 发表于 2023-4-26 09:15:15

cchessbd 发表于 2023-4-26 08:45
块不需要保留,主要是文字最好保留之前的。
比如,我的操作是,选择一些对象,建块,缩放。
建块是很容 ...

如果是我我会选择对象 的时候就把文字过滤掉,文字就不在块里面

cchessbd 发表于 2023-4-26 10:32:46

liuhe 发表于 2023-4-26 09:15
如果是我我会选择对象 的时候就把文字过滤掉,文字就不在块里面
文字是高程里程数据,缩放时必须选择,这样位置才能一一对应

liuhe 发表于 2023-4-26 10:33:49

cchessbd 发表于 2023-4-26 10:32
文字是高程数据,缩放时必须一一对应

你上图纸吧,写好原图形和目标图形

liuhe 发表于 2023-4-26 13:43:42

cchessbd 发表于 2023-4-26 10:54
感谢大侠来研究,,,主要是我这个元素太多了,一项项改真的很累。。。
而且几十个桥。。。



我加你qq或者你加我也行

kucha007 发表于 2023-4-26 14:20:10

本帖最后由 kucha007 于 2023-4-26 14:28 编辑

搞错了= ====
页: [1] 2
查看完整版本: 块缩放后(调整了XY比例),怎么把文字大小变为原来的呢?